=== modified file 'debian/changelog'
--- debian/changelog	2009-11-03 22:41:38 +0000
+++ debian/changelog	2009-12-13 12:06:07 +0000
@@ -1,3 +1,12 @@
+expat (2.0.1-6) unstable; urgency=medium
+
+  * debian/patches/560901_CVE_2009_3560.dpatch: Added.
+    - lib/xmlparse.c (doProlog): Fix DoS vulnerability CVE-2009-3560 (closes:
+      #560901).
+  * debian/patches/00list: Adjusted.
+
+ -- Daniel Leidert (dale) <daniel.leidert@wgdd.de>  Sun, 13 Dec 2009 12:06:07 +0100
+
 expat (2.0.1-5) unstable; urgency=medium
 
   * debian/control (Standards-Version): Bumped to 3.8.3.
@@ -9,7 +18,7 @@
   * debian/README.source: Added for policy compliance.
   * debian/patches/551936_CVE_2009_2625.dpatch: Added.
     - lib/xmltok_impl.c (updatePosition): Fix DoS vulnerability CVE-2009-2625
-      (closes: #551936).
+      and CVE-2009-3720 (closes: #551936).
   * debian/patches/00list: Adjusted.
 
  -- Daniel Leidert (dale) <daniel.leidert@wgdd.de>  Tue, 03 Nov 2009 22:41:38 +0100

=== modified file 'debian/patches/00list'
--- debian/patches/00list	2009-11-03 22:41:38 +0000
+++ debian/patches/00list	2009-12-13 12:06:07 +0000
@@ -4,3 +4,4 @@
 412786_xmlwf_man_standard_fix
 485129_fix_underquotation_in_m4
 551936_CVE_2009_2625
+560901_CVE_2009_3560

=== added file 'debian/patches/560901_CVE_2009_3560.dpatch'
--- debian/patches/560901_CVE_2009_3560.dpatch	1970-01-01 00:00:00 +0000
+++ debian/patches/560901_CVE_2009_3560.dpatch	2009-12-13 12:06:07 +0000
@@ -0,0 +1,28 @@
+#! /bin/sh /usr/share/dpatch/dpatch-run
+## 560901_CVE_2009_3560.dpatch by Daniel Leidert (dale) <daniel.leidert@wgdd.de>
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: The big2_toUtf8 function in lib/xmltok.c in libexpat in Expat 2.0.1, as
+## DP: used in the XML-Twig module for Perl, allows context-dependent attackers
+## DP: to cause a denial of service (application crash) via an XML document
+## DP: with malformed UTF-8 sequences that trigger a buffer over-read, related
+## DP: to the doProlog function in lib/xmlparse.c, a different vulnerability
+## DP: than CVE-2009-2625 and CVE-2009-3720. 
+## DP:
+## DP: <URL:http://bugs.debian.org/560901>
+## DP: <URL:http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-3560>
+## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?r1=1.164&r2=1.165>
+## DP: <URL:http://expat.cvs.sourceforge.net/viewvc/expat/expat/lib/xmlparse.c?view=log#rev1.165>
+
+@DPATCH@
+diff -urNad lenny~/lib/xmlparse.c lenny/lib/xmlparse.c
+--- lenny~/lib/xmlparse.c	2007-05-08 04:25:35.000000000 +0200
++++ lenny/lib/xmlparse.c	2009-12-13 11:39:18.671629559 +0100
+@@ -3725,7 +3725,6 @@
+         return XML_ERROR_NO_ELEMENTS;
+       default:
+         tok = -tok;
+-        next = end;
+         break;
+       }
+     }

